<?php

/**
 * @file
 * Miniorange 2 factor configuration page.
 */

/**
 * TFA Country code array
 */

function phone_country_codes() {
  return array(
    "+91" => "India +91",
    "+1" => "United States +1",
    "+93" => "Afghanistan +93",
    "+355" => "Albania +355",
    "+213" => "Algeria +213",
    "+1684" => "American Samoa +1684",
    "+376" => "Andorra +376",
    "+244" => "Angola +244",
    "+1264" => "Anguilla +1264",
    "+1268" => "Antigua and Barbuda +1268",
    "+54" => "Argentina +54",
    "+374" => "Armenia +374",
    "+297" => "Aruba +297",
    "+61" => "Australia +61",
    "+43" => "Austria +43",
    "+994" => "Azerbaijan +994",
    "+1242" => "Bahamas +1242",
    "+973" => "Bahrain +973",
    "+880" => "Bangladesh +880",
    "+1246" => "Barbados +1246",
    "+375" => "Belarus +375",
    "+32" => "Belgium +32",
    "+501" => "Belize +501",
    "+229" => "Benin +229",
    "+1441" => "Bermuda +1441",
    "+975" => "Bhutan +975",
    "+591" => "Bolivia +591",
    "+387" => "Bosnia and Herzegovina +387",
    "+267" => "Botswana +267",
    "+55" => "Brazil +55",
    "+673" => "Brunei Darussalam +673",
    "+359" => "Bulgaria +359",
    "+226" => "Burkina Faso +226",
    "+257" => "Burundi +257",
    "+855" => "Cambodia +855",
    "+237" => "Cameroon +237",
    "+1" => "Canada +1",
    "+238" => "Cape Verde +238",
    "+1345" => "Cayman Islands +1345",
    "+236" => "Central African Republic +236",
    "+235" => "Chad +235",
    "+56" => "Chile +56",
    "+86" => "China +86",
    "+57" => "Colombia +57",
    "+269" => "Comoros +269",
    "+243" => "Congo (DRC) +243",
    "+242" => "Congo (Republic) +242",
    "+682" => "Cook Islands +682",
    "+506" => "Costa Rica +506",
    "+225" => "Côte d'Ivoire +225",
    "+385" => "Croatia +385",
    "+53" => "Cuba +53",
    "+357" => "Cyprus +357",
    "+420" => "Czech Republic +420",
    "+45" => "Denmark +45",
    "+253" => "Djibouti +253",
    "+1767" => "Dominica +1767",
    "+1809" => "Dominican Republic +1809",
    "+593" => "Ecuador +593",
    "+20" => "Egypt +20",
    "+503" => "El Salvador +503",
    "+240" => "Equatorial Guinea +240",
    "+291" => "Eritrea +291",
    "+372" => "Estonia +372",
    "+251" => "Ethiopia +251",
    "+298" => "Faroe Islands +298",
    "+679" => "Fiji +679",
    "+358" => "Finland +358",
    "+33" => "France +33",
    "+689" => "French Polynesia +689",
    "+241" => "Gabon +241",
    "+220" => "Gambia +220",
    "+995" => "Georgia +995",
    "+49" => "Germany +49",
    "+233" => "Ghana +233",
    "+350" => "Gibraltar +350",
    "+30" => "Greece +30",
    "+299" => "Greenland +299",
    "+1473" => "Grenada +1473",
    "+590" => "Guadeloupe +590",
    "+1671" => "Guam +1671",
    "+502" => "Guatemala +502",
    "+44" => "Guernsey +44",
    "+224" => "Guinea +224",
    "+245" => "Guinea-Bissau +245",
    "+592" => "Guyana +592",
    "+509" => "Haiti +509",
    "+504" => "Honduras +504",
    "+852" => "Hong Kong +852",
    "+36" => "Hungary +36",
    "+354" => "Iceland +354",
    "+91" => "India +91",
    "+62" => "Indonesia +62",
    "+98" => "Iran +98",
    "+964" => "Iraq +964",
    "+353" => "Ireland +353",
    "+44" => "Isle of Man +44",
    "+972" => "Israel +972",
    "+39" => "Italy +39",
    "+1876" => "Jamaica +1876",
    "+81" => "Japan +81",
    "+44" => "Jersey +44",
    "+962" => "Jordan +962",
    "+7" => "Kazakhstan +7",
    "+254" => "Kenya +254",
    "+686" => "Kiribati +686",
    "+965" => "Kuwait +965",
    "+996" => "Kyrgyzstan +996",
    "+856" => "Laos +856",
    "+371" => "Latvia +371",
    "+961" => "Lebanon +961",
    "+266" => "Lesotho +266",
    "+231" => "Liberia +231",
    "+218" => "Libya +218",
    "+423" => "Liechtenstein +423",
    "+370" => "Lithuania +370",
    "+352" => "Luxembourg +352",
    "+853" => "Macao +853",
    "+389" => "Macedonia +389",
    "+261" => "Madagascar +261",
    "+265" => "Malawi +265",
    "+60" => "Malaysia +60",
    "+960" => "Maldives +960",
    "+223" => "Mali +223",
    "+356" => "Malta +356",
    "+692" => "Marshall Islands +692",
    "+596" => "Martinique +596",
    "+222" => "Mauritania +222",
    "+230" => "Mauritius +230",
    "+52" => "Mexico +52",
    "+691" => "Micronesia +691",
    "+373" => "Moldova +373",
    "+377" => "Monaco +377",
    "+976" => "Mongolia +976",
    "+382" => "Montenegro +382",
    "+1664" => "Montserrat +1664",
    "+212" => "Morocco +212",
    "+258" => "Mozambique +258",
    "+95" => "Myanmar (Burma) +95",
    "+264" => "Namibia +264",
    "+674" => "Nauru +674",
    "+977" => "Nepal +977",
    "+31" => "Netherlands +31",
    "+687" => "New Caledonia +687",
    "+64" => "New Zealand +64",
    "+505" => "Nicaragua +505",
    "+227" => "Niger +227",
    "+234" => "Nigeria +234",
    "+850" => "North Korea +850",
    "+47" => "Norway +47",
    "+968" => "Oman +968",
    "+92" => "Pakistan +92",
    "+680" => "Palau +680",
    "+970" => "Palestinian Territory +970",
    "+507" => "Panama +507",
    "+675" => "Papua New Guinea +675",
    "+595" => "Paraguay +595",
    "+51" => "Peru +51",
    "+63" => "Philippines +63",
    "+48" => "Poland +48",
    "+351" => "Portugal +351",
    "+1787" => "Puerto Rico +1787",
    "+974" => "Qatar +974",
    "+262" => "Réunion +262",
    "+40" => "Romania +40",
    "+7" => "Russian Federation +7",
    "+250" => "Rwanda +250",
    "+1869" => "Saint Kitts and Nevis +1869",
    "+1758" => "Saint Lucia +1758",
    "+1784" => "Saint Vincent and the Grenadines +1784",
    "+685" => "Samoa +685",
    "+378" => "San Marino +378",
    "+239" => "São Tomé and Príncipe +239",
    "+966" => "Saudi Arabia +966",
    "+221" => "Senegal +221",
    "+381" => "Serbia +381",
    "+248" => "Seychelles +248",
    "+232" => "Sierra Leone +232",
    "+65" => "Singapore +65",
    "+421" => "Slovakia +421",
    "+386" => "Slovenia +386",
    "+677" => "Solomon Islands +677",
    "+252" => "Somalia +252",
    "+27" => "South Africa +27",
    "+82" => "South Korea +82",
    "+34" => "Spain +34",
    "+94" => "Sri Lanka +94",
    "+249" => "Sudan +249",
    "+597" => "Suriname +597",
    "+268" => "Swaziland +268",
    "+46" => "Sweden +46",
    "+41" => "Switzerland +41",
    "+963" => "Syrian Arab Republic +963",
    "+886" => "Taiwan, Province of China +886",
    "+992" => "Tajikistan +992",
    "+255" => "Tanzania +255",
    "+66" => "Thailand +66",
    "+670" => "Timor-Leste +670",
    "+228" => "Togo +228",
    "+676" => "Tonga +676",
    "+1868" => "Trinidad and Tobago +1868",
    "+216" => "Tunisia +216",
    "+90" => "Turkey +90",
    "+993" => "Turkmenistan +993",
    "+1649" => "Turks and Caicos Islands +1649",
    "+688" => "Tuvalu +688",
    "+256" => "Uganda +256",
    "+380" => "Ukraine +380",
    "+971" => "United Arab Emirates +971",
    "+44" => "United Kingdom +44",
    "+1" => "United States +1",
    "+598" => "Uruguay +598",
    "+998" => "Uzbekistan +998",
    "+678" => "Vanuatu +678",
    "+379" => "Vatican City +379",
    "+58" => "Venezuela +58",
    "+84" => "Viet Nam +84",
    "+1284" => "Virgin Islands (British) +1284",
    "+1340" => "Virgin Islands (U.S.) +1340",
    "+212" => "Western Sahara +212",
    "+967" => "Yemen +967",
    "+260" => "Zambia +260",
    "+263" => "Zimbabwe +263",
  );
}

/**
 * TFA Setting page for profile.
 */
function tfa_user_profile($form, &$form_state) {
  // Display OTP validation form if status is either on
  // TWO_FACTOR_AUTHENTICATION_MO_2_FACTOR_OTP_DELIVERED_SUCCESS or
  // TWO_FACTOR_AUTHENTICATION_MO_2_FACTOR_OTP_DELIVERED_FAILURE.
  global $user;
  $country_codes = phone_country_codes();
  $users_active_methods = array(
    TWO_FACTOR_AUTHENTICATION_EMAIL_VERIFICATION => t('Email Verification'),
    TWO_FACTOR_AUTHENTICATION_QR_CODE_AUTHENTICATION => t('QR Code Authentication'),
    TWO_FACTOR_AUTHENTICATION_GOOGLE_AUTHENTICATOR => t('Google Authenticator')
  );
  $user_obj = user_load($user->uid);
  if (!empty($user_obj->field_registration_status[LANGUAGE_NONE][0]['value']) && in_array(
        $user_obj->field_registration_status[LANGUAGE_NONE][0]['value'], array(
          TWO_FACTOR_AUTHENTICATION_MO_2_FACTOR_OTP_DELIVERED_SUCCESS,
          TWO_FACTOR_AUTHENTICATION_MO_2_FACTOR_OTP_DELIVERED_FAILURE,
        )
    )) {

    drupal_add_library('system', 'drupal.ajax');

    $output = l(
          t('Resend OTP ?'), 'user/' . $user_obj->uid . '/nojs/tfa/resend-otp', array(
            'attributes' => array('class' => array('use-ajax')),
          )
      );

    $form['otp'] = array(
      '#type' => 'password',
      '#title' => t('Enter OTP'),
      '#required' => TRUE,
      '#prefix' => '<div class= "resend-otp"></div>',
      '#suffix' => $output,
    );

    $form['validate_otp'] = array(
      '#type' => 'submit',
      '#value' => t('Validate OTP'),
    );

    $form['back_to_user_account_'] = array(
      '#type' => 'submit',
      '#value' => t('Back'),
      '#prefix' => '<br/>',
    );
  }
  // If user has entered wrong password and if its already registered.
  elseif (!empty($user_obj->field_registration_status[LANGUAGE_NONE][0]['value']) && $user_obj->field_registration_status[LANGUAGE_NONE][0]['value'] == TWO_FACTOR_AUTHENTICATION_MO_2_FACTOR_VERIFY_CUSTOMER && !empty($_SESSION['check_set'])) {
    $form['email'] = array(
      '#type' => 'textfield',
      '#title' => t('Email'),
      '#default_value' => !empty($user_obj->field_miniorange_email[LANGUAGE_NONE][0]['value']) ? $user_obj->field_miniorange_email[LANGUAGE_NONE][0]['value'] : '',
      '#required' => TRUE,
    );

    $form['password'] = array(
      '#type' => 'password',
      '#title' => t('Password'),
      '#attributes' => array(
        'placeholder' => t('Enter your miniorange password'),
      ),
      '#required' => TRUE,
    );

    $form['login_submit'] = array(
      '#type' => 'submit',
      '#value' => t('Submit'),
      '#suffix' => l(t('Forgot your password?'), variable_get('two_factor_authentication_mo2f_host_name') . '/moas/idp/userforgotpassword'),
    );

    $form['back_to_user_account'] = array(
      '#type' => 'submit',
      '#value' => t('Back'),
      '#prefix' => '<br/>',
    );
  }
  // If admin/customer is registered with miniorange,
  // show the detail in tabular form.
  elseif (!empty($user_obj->field_registration_status[LANGUAGE_NONE][0]['value']) && in_array(
        $user_obj->field_registration_status[LANGUAGE_NONE][0]['value'], array(
          TWO_FACTOR_AUTHENTICATION_MO_2_FACTOR_INITIALIZE_MOBILE_REGISTRATION,
          TWO_FACTOR_AUTHENTICATION_MO_2_FACTOR_PLUGIN_SETTINGS,
        )
    )) {

    $header = array('title' => t('Title'), 'value' => t('Value'));

    $rows[] = array(
      'title' => '2 Factor Registered Email',
      'value' => !empty($user_obj->mail) ? $user_obj->mail . ' (admin)' : '',
    );

    $rows[] = array(
      'title' => 'miniOrange Customer Email',
      'value' => !empty($user_obj->field_miniorange_email[LANGUAGE_NONE][0]['value']) ? $user_obj->field_miniorange_email[LANGUAGE_NONE][0]['value'] : '',
    );

    $active_method_key = $user_obj->field_active_methods[LANGUAGE_NONE][0]['value'];
    $users_active_method_name = $users_active_methods[$active_method_key];
    $rows[] = array(
      'title' => 'Activated 2nd Factor',
      'value' => !empty($user_obj->field_active_methods[LANGUAGE_NONE][0]['value']) ? $users_active_method_name : '',
    );

    if (in_array('authenticated user', $user_obj->roles)) {
      $rows[] = array(
        'title' => 'Customer ID',
        'value' => variable_get('two_factor_authentication_mo2f_customerKey'),
      );
      $rows[] = array(
        'title' => 'API Key',
        'value' => variable_get('two_factor_authentication_mo2f_api_key'),
      );
      $rows[] = array(
        'title' => 'Token Key',
        'value' => variable_get('two_factor_authentication_mo2f_customer_token'),
      );
      $rows[] = array(
        'title' => 'App Secret',
        'value' => variable_get('two_factor_authentication_mo2f_customer_appSecret'),
      );
    }

    $table = theme('table', array('header' => $header, 'rows' => $rows));

    $form['my_info'] = array(
      '#type' => 'item',
      '#markup' => t('<p>Thank you for registering with miniOrange.</p><h4>Your Profile</h4>'),
      '#suffix' => $table,
    );

    if (empty($user_obj->field_active_methods[LANGUAGE_NONE]) || $user_obj->field_active_methods[LANGUAGE_NONE][0]['value'] == '_none') {

      $form['mobile_conf_status']['#markup'] = 'Please ' . l(t("click here"), "admin/config/mo2f/mo2f_tfa/setup-two-factor") . ' to configure your mobile to complete the 2 Factor setup.';
    }
  }
  // Else display the form to register a new admin/customer.
  elseif (empty($user_obj->field_registration_status[LANGUAGE_NONE][0]['value']) || empty($_SESSION['check_set'])) {

    // Dispaly registration form for authenticated user.
    if (in_array('authenticated user', $user_obj->roles)) {

      $form['register'] = array(
        '#type' => 'fieldset',
        '#title' => t('Register with miniOrange'),
        '#description' => t('<div class ="registerinfo">Please enter a valid email id that you have access to. You will be able to move forward after verifying an OTP that we will be sending to this email. <a name="set_session" href="@already">Already registered with miniOrange?</a></div>', array(
            '@already' => url('user/tfa/set-session', array('html' => TRUE)),
          )
        ),
        'collapsible' => FALSE,
        'collapsed' => FALSE,
      );

      $form['register']['email'] = array(
        '#type' => 'textfield',
        '#title' => t('Email'),
        '#default_value' => $user_obj->mail,
        '#required' => TRUE,
      );

      $form['register']['country_code'] = array(
        '#type' => 'select',
        '#options' => $country_codes,
        '#default_value' => '+1',
      );

      $form['register']['phone'] = array(
        '#type' => 'textfield',
        '#title' => t('Phone number'),
        '#required' => FALSE,
        '#size' => 50,
      );

      $form['register']['clear'] = array(
        '#type' => 'item',
        '#prefix' => '<div class="clear">',
        '#suffix' => '</div>',
      );

      $form['register']['password'] = array(
        '#type' => 'password',
        '#title' => t('Password'),
        '#required' => TRUE,
      );

      $form['register']['confirm_password'] = array(
        '#type' => 'password',
        '#title' => t('Confirm Password'),
        '#required' => TRUE,
      );

      $form['register']['submit'] = array('#type' => 'submit', '#value' => t('Get Started'));
    }
    // Display registration form for customer.
    else {
      $form['email'] = array(
        '#type' => 'textfield',
        '#title' => t('Email'),
        '#default_value' => $user_obj->mail,
        '#prefix' => '<div>miniOrange 2 Factor Authentication has been enabled for you. Please set up your account and register yourself by following the steps.</div>',
        '#suffix' => '<div>Please enter a valid email id that you have access to. We need this email to send OTP in case you forgot or lost your phone.</div>',
        '#required' => TRUE,
      );
      $form['submit'] = array('#type' => 'submit', '#value' => t('Get Started'));
    }
  }

  return $form;
}

/**
 * Validate function for above form.
 */
function tfa_user_profile_validate($form, &$form_state) {
  // This is checked here because name and password fields gets
  // validate and form is not redirected.
  if (isset($form_state['triggering_element']) && $form_state['triggering_element']['#parents'][0] == 'back_to_user_account') {
    unset($_SESSION['check_set']);
    drupal_get_messages();
    drupal_goto('admin/config/mo2f/mo2f_tfa');
    exit;
  }
  elseif (isset($form_state['triggering_element']) && $form_state['triggering_element']['#parents'][0] == 'back_to_user_account_') {
    unset($_SESSION['check_set']);
    global $user;
    $user_obj = user_load($user->uid);
    $user_obj->field_registration_status[LANGUAGE_NONE][0]['value'] = '_none';
    user_save($user_obj);
    drupal_get_messages();
    drupal_goto('admin/config/mo2f/mo2f_tfa');
    exit;
  }
}

/**
 * Hook submit for profile page.
 */
function tfa_user_profile_submit($form, &$form_state) {

  global $user;
  $user_obj = user_load($user->uid);
  $email = (!empty($form_state['values']['email'])) ? $form_state['values']['email'] : '';
  $password = (!empty($form_state['values']['password'])) ? $form_state['values']['password'] : '';

  // Create a new user in miniorange against customer id.
  if (isset($form_state['triggering_element']) && $form_state['triggering_element']['#parents'][0] == 'submit') {
    // Check if user already exist in miniorange database.
    $enduser = new Two_Factor_Setup();
    $check_user = json_decode($enduser->mo_check_user_already_exist($email), TRUE);

    // If user is other than admin.
    if (!in_array('administrator', $user_obj->roles)) {

      if (json_last_error() == JSON_ERROR_NONE) {
        if (isset($check_user['statusCode']) && $check_user['statusCode'] == 'ERROR') {
          if(!empty($check_user['statusMessage']))
            drupal_set_message($check_user['statusMessage'], 'error');
        }
        else {
          if (strcasecmp($check_user['status'], 'USER_FOUND') == 0) {
            $user_obj->field_registration_status[LANGUAGE_NONE][0]['value'] = TWO_FACTOR_AUTHENTICATION_MO_2_FACTOR_INITIALIZE_MOBILE_REGISTRATION;
            $user_obj->field_active_methods[LANGUAGE_NONE][0]['value'] = array(TWO_FACTOR_AUTHENTICATION_EMAIL_VERIFICATION);
            $user_obj->field_configured_methods[LANGUAGE_NONE][0]['value'] = array(TWO_FACTOR_AUTHENTICATION_EMAIL_VERIFICATION);
            $user_obj->field_miniorange_email[LANGUAGE_NONE][0]['value'] = $form_state['values']['email'];
            // Validate customer.
            mo2f_fetch_customer($user_obj, $email, $password);
          }
          // If user not found, create a Customer at miniorange.
          elseif (strcasecmp($check_user['status'], 'USER_NOT_FOUND') == 0) {
            $content = json_decode($enduser->mo_create_user($user_obj, $email), TRUE);
            if (json_last_error() == JSON_ERROR_NONE) {
              if (isset($content['statusCode']) && $content['statusCode'] == 'ERROR') {
                if(!empty($content['statusMessage']))
                  drupal_set_message($content['statusMessage'], 'error');
              }
              else {
                if (strcasecmp($content['status'], 'SUCCESS') == 0) {
                  $user_obj->field_registration_status[LANGUAGE_NONE][0]['value'] = TWO_FACTOR_AUTHENTICATION_MO_2_FACTOR_INITIALIZE_MOBILE_REGISTRATION;
                  $user_obj->field_active_methods[LANGUAGE_NONE][0]['value'] = array(TWO_FACTOR_AUTHENTICATION_EMAIL_VERIFICATION);
                  $user_obj->field_configured_methods[LANGUAGE_NONE][0]['value'] = array(TWO_FACTOR_AUTHENTICATION_EMAIL_VERIFICATION);
                  $user_obj->field_miniorange_email[LANGUAGE_NONE][0]['value'] = $form_state['values']['email'];

                  // Update miniorange about the default set method.
                  $enduser->mo2f_update_userinfo($email, 'EMAIL', NULL, NULL, NULL);

                  drupal_set_message(t('Your account has been created successfully. Email Verification has been set as your default 2nd factor method. <a href="@clickhere">Click Here</a> to configure another 2nd factor authentication method.', array(
                      '@clickhere' => url('admin/config/mo2f/mo2f_tfa/setup-two-factor', array('absolute' => TRUE)),
                    )
                  ));
                }
                else {
                  drupal_set_message(t('Error occurred while adding the user. Please try again or contact your admin.'), 'error');
                }
              }
            }
            else {
              drupal_set_message(t('Error occurred while adding the user. Please try again or contact your admin.'), 'error');
            }
          }
          elseif (strcasecmp($check_user['status'], 'USER_FOUND_UNDER_DIFFERENT_CUSTOMER') == 0) {
            // Get detail of the admin from miniorange,
            // if it exist in the system.
            mo2f_fetch_customer($user_obj, $email, $password);
          }
          elseif ($check_user['status'] == 'ERROR' && strcasecmp($check_user['message'], 'Invalid customer key.') == 0) {
            drupal_set_message(t('Invalid password, Please try again.'), 'error');
            drupal_goto('user/tfa/set-session');
            exit;
          }
          else {
            drupal_set_message(t('Error occurred while adding the user. Please try again or contact your admin.'), 'error');
          }
        }
      }
      else {
        drupal_set_message(t('Error occurred while adding the user. Please try again or contact your admin.'), 'error');
      }
    }
    else {

      // Register a new customer in miniorange.
      if (strcmp($form_state['values']['password'], $form_state['values']['confirm_password']) == 0) {

        $password = $form_state['values']['password'];
        variable_set('mo2f_password', $password);
        $user_obj->field_miniorange_email[LANGUAGE_NONE][0]['value'] = $form_state['values']['email'];
        variable_set('two_factor_authentication_mo2f_phone', $form_state['values']['phone']);

        // Check if customer already exist.
        $customer = new Customer_Setup();
        $customer_key = json_decode($customer->check_customer($email), TRUE);

        if (isset($customer_key['statusCode']) && $customer_key['statusCode'] == 'ERROR') {
          if(!empty($customer_key['statusMessage']))
            drupal_set_message($customer_key['statusMessage'], 'error');
        }
        else {
          if (strcasecmp($customer_key['status'], 'CUSTOMER_NOT_FOUND') == 0) {
            tfa_user_send_otp($user_obj);
            drupal_set_message(t('An OTP has been sent to your email. Please enter the OTP below to verify your account.'));
          }
          else {
            // Get detail of the admin from miniorange,
            // if it exist in the system.
            mo2f_fetch_customer($user_obj, $email, $password);
          }
        }
      }
      else {
        form_set_error('password', t('Password and Confirm password do not match.'));
      }
    }
  }
  elseif (isset($form_state['triggering_element']) && $form_state['triggering_element']['#parents'][0] == 'validate_otp') {
    $otp_token = $form_state['values']['otp'];
    // Validate the OTP form miniorange auth.
    $customer = new Customer_Setup();
    $content = json_decode($customer->validate_otp_token('EMAIL', NULL, $_SESSION['mo2f']['mo2f_transactionId'], $otp_token), TRUE);

    if (!empty($content['statusCode']) && $content['statusCode'] == 'ERROR') {
      if(!empty($content['statusMessage']))
        drupal_set_message($content['statusMessage'], 'error');
    }
    else {
      if (strcasecmp($content['status'], 'SUCCESS') == 0) {
        // OTP validated and generate QRCode.
        mo2f_create_customer($user_obj);
      }
      else {

        // OTP Validation failed.
        drupal_set_message(t('Invalid OTP. Please try again.'), 'error');
        $user_obj->field_registration_status[LANGUAGE_NONE][0]['value'] = TWO_FACTOR_AUTHENTICATION_MO_2_FACTOR_OTP_DELIVERED_FAILURE;
      }
    }
  }
  elseif (isset($form_state['triggering_element']) && $form_state['triggering_element']['#parents'][0] == 'contact_submit') {
    $email = $form_state['values']['email'];
    $phone = $form_state['values']['phone'];
    $query = $form_state['values']['query'];
    // Post Query to miniorange through its api.
    $contact_us = new customer_setup();
    $submited = json_decode($contact_us->submit_contact_us($email, $phone, $query), TRUE);
    if (json_last_error() == JSON_ERROR_NONE) {
      if ($submited['statusCode'] == 'ERROR') {
        if(!empty($submited['statusCode']))
          drupal_set_message($submited['statusMessage']);
      }
      else {
        if ($submited == FALSE) {
          drupal_set_message(t('Your query could not be submitted. Please try again.'), 'error');
        }
        else {
          drupal_set_message(t('Thanks for getting in touch! We shall get back to you shortly.'));
        }
      }
    }
  }
  elseif (isset($form_state['triggering_element']) && $form_state['triggering_element']['#parents'][0] == 'login_submit') {
    $password = $form_state['values']['password'];
    $user_obj->field_miniorange_email[LANGUAGE_NONE][0]['value'] = $form_state['values']['email'];
    mo2f_fetch_customer($user_obj, $email, $password);
  }
  elseif (isset($form_state['triggering_element']) && $form_state['triggering_element']['#parents'][0] == 'back_to_user_account') {
    unset($_SESSION['check_set']);
    $user_obj->field_registration_status[LANGUAGE_NONE][0]['value'] = '';
  }

  user_save($user_obj);
}

/**
 * Function to already registered login form for miniorange.
 */
function tfa_user_already_registered($form, &$form_state) {

  global $user;
  $user_obj = user_load($user->uid);

  if (empty($user_obj->field_registration_status[LANGUAGE_NONE][0]['value'])) {
    $form['header']['#markup'] = t('<h4>Login with miniOrange</h4><div>It seems you already have an account with miniOrange. Please enter your miniOrange email and password. <a href="@forgot">Click here if you forgot your password?</a></div>', array(
        '@forgot' => variable_get('two_factor_authentication_mo2f_host_name') . '/moas/idp/userforgotpassword',
      )
    );
    $form['email'] = array(
      '#type' => 'textfield',
      '#title' => t('Email'),
      '#default_value' => isset($user_obj->field_miniorange_email[LANGUAGE_NONE][0]['value']) ? $user_obj->field_miniorange_email[LANGUAGE_NONE][0]['value'] : '',
      '#required' => TRUE,
    );

    $form['password'] = array(
      '#type' => 'password',
      '#title' => t('Password'),
      '#attributes' => array(
        'placeholder' => t('Enter your miniorange password'),
      ),
      '#required' => TRUE,
    );

    $form['login_submit'] = array(
      '#type' => 'submit',
      '#value' => t('Submit'),
    );

    $form['back_to_user_account'] = array(
      '#type' => 'submit',
      '#value' => t('Back'),
    );
  }
  return $form;
}

/**
 * Validate function for already registered form.
 */
function tfa_user_already_registered_validate($form, &$form_state) {
  // This is checked here because name and password fields gets
  // validate and form is not redirected.
  if (isset($form_state['triggering_element']) && $form_state['triggering_element']['#parents'][0] == 'back_to_user_account') {
    unset($_SESSION['check_set']);
    drupal_get_messages();
    drupal_goto('admin/config/mo2f/mo2f_tfa');
    exit;
  }
}

/**
 * Function to handle miniorange already registered form submit.
 */
function tfa_user_already_registered_submit($form, &$form_state) {

  global $user;
  $user_obj = user_load($user->uid);
  $email = $form_state['values']['email'];
  if (isset($form_state['triggering_element']) && $form_state['triggering_element']['#parents'][0] == 'login_submit') {
    $user_obj->field_miniorange_email[LANGUAGE_NONE][0]['value'] = $form_state['values']['email'];
    $form_state['redirect'] = 'admin/config/mo2f/mo2f_tfa';
    $password = $form_state['values']['password'];
    mo2f_fetch_customer($user_obj, $email, $password);
    unset($_SESSION['check_set']);
  }
  elseif (isset($form_state['triggering_element']) && $form_state['triggering_element']['#parents'][0] == 'back_to_user_account') {
    unset($_SESSION['check_set']);
    drupal_goto('admin/config/mo2f/mo2f_tfa');
  }
  user_save($user_obj);
}

/**
 * Set a session.
 */
function set_session() {

  $_SESSION['check_set'] = "set";
  drupal_set_message('Please enter your registered email and password.', 'status');
  drupal_goto('admin/config/mo2f/mo2f_tfa');
}

/**
 * Function to check which form to show for miniorange.
 */
function user_account_setup() {

  $output = array();
  if (!empty($_SESSION['check_set'])) {
    // Will return the Already registered form if variable is set.
    $output = drupal_get_form('tfa_user_already_registered');
    return $output;
  }
  $output['register'] = drupal_get_form('tfa_user_profile');
  return $output;
}

/**
 * Page to cofigure mobile against a user.
 */
function tfa_user_configure_mobile($form, &$form_state) {

  global $user;
  $user_obj = user_load($user->uid);
  $configured_methods = array();
  $configured_methods = configured_methods_variable();

  // Show QR Code to the user, if SESSION set for "mo2f_show_qr_code".
  if (isset($_SESSION['mo2f']['mo2f_show_qr_code']) && isset($_GET['qrcode'])) {
    $path = drupal_get_path('module', 'two_factor_authentication');
    $url = variable_get('two_factor_authentication_mo2f_host_name');
    $form['#attached']['js'][] = array(
      'data' => array(
        'two_factor_authentication' => array(
          'mo2f_qrCode' => $_SESSION['mo2f']['mo2f_transactionId'],
          'path' => $path,
          'url' => $url,
        ),
      ),
      'type' => 'setting',
    );

    $data = $_SESSION['mo2f']['mo2f_qrCode'];

    $html = '';
    // Show configure QR Code to scan.
    if ($_SESSION['mo2f']['mo2f_show_qr_code'] == 'MO_2_FACTOR_SHOW_QR_CODE_CONFIGURE') {
      $html = '<p>Open your <b>miniOrange Authenticator</b> app and click on <b>Configure button</b> to scan the QR code. Your phone should have internet connectivity to scan QR code.</p><p><span class="textcolorred">I am not able to scan the QR code</span>, <span id="disptext"><a href="#">click here</a></span><div class="scanqr closed"> <br>Follow these instructions below and try again.
				<ol>
					<li>Make sure your desktop screen has enough brightness.</li>
					<li>Open your app and click on Green button (your registered email is displayed on the button) to scan QR Code.</li>
					<li>If you get cross mark on QR Code then click on \'Back\' button and again click on \'Test\' link.</li></div></p>
<p><a href="#"><span id="refresh_qr">Click here to Refresh QR Code.</span></a></p>

            <table class="mo2f_settings_table">
                <div id="displayQrCode" class="qr_configure"><img src="data:image/jpg;base64,' . $data . '" />
                </div>
            </table>';
    }
    // Show test QR Code to scan.
    elseif ($_SESSION['mo2f']['mo2f_show_qr_code'] == 'MO_2_FACTOR_SHOW_QR_CODE_TEST') {
      $html = '<p><b>Open your <b>miniOrange Authenticator</b> App and click on <b>Authenticate button</b> to scan the QR code.</b></p>

			<table class="mo2f_settings_table">
				<div id="displayQrCode" class="qr_validate"><img src="data:image/jpg;base64,' . $data . '" />
				</div>
			</table>';
    }

    $form['mobile_conf_qrcode']['#markup'] = $html;
  }else{
    $html_instruction = theme('tfa_mobile_config');

    $form['mobile_conf'] = array(
        '#type' => 'fieldset',
        '#title' => t('Click here to see Authenticator App download instructions.'),
        '#collapsible' => TRUE,
        '#collapsed' => TRUE,
        '#access' => user_access(TRUE),
    );
     $form['mobile_conf']['markup_field'] = array(
      '#type' => 'item',
      '#markup' => $html_instruction,
    );

  }

  $html_mark = '';
  $form['back']['#type'] = 'submit';
  $form['back']['#value'] = t('Back');

  $form['configure_phone'] = array(
      '#type' => 'submit',
      '#markup' => $html_mark,
      '#value' => t('Configure your phone'),
  );

  // Disable configure option for mobile,
  // if user is not setup at miniornage auth.
  if (empty($user_obj->field_registration_status[LANGUAGE_NONE]) || $user_obj->field_registration_status[LANGUAGE_NONE][0]['value'] == 0) {
    $form['mobile_conf_status']['#markup'] = 'Please ' . l(t("Register with miniOrange"), "user/" . $user_obj->uid . "/tfa/user-profile") . ' to configure miniOrange 2 Factor plugin.';
    $form['configure_phone']['#disabled'] = TRUE;
  }
  // If mobile is already configured,
  // show Reconfigure option to the user.
  if (in_array(TWO_FACTOR_AUTHENTICATION_QR_CODE_AUTHENTICATION, $configured_methods)) {
    $form['configure_phone']['#value'] = t('Reconfigure your phone');
  }

  $form['qr_scan_submit'] = array(
      '#type' => 'submit',
      '#value' => t('QR Submit'),
      '#attributes' => array('class' => array('element-invisible')),
  );

  return $form;
}

/**
 * Submit handler to configure mobile.
 */
function tfa_user_configure_mobile_submit($form, $form_state) {

  // Check if clicked back button.
  if (!empty($form_state['triggering_element']) && $form_state['triggering_element']['#parents'][0] == 'back') {
    unset($_SESSION['check_set']);
    drupal_goto('admin/config/mo2f/mo2f_tfa/setup-two-factor');
    exit;
  }

  global $user;
  $configured_methods = array();
  $configured_methods = configured_methods_variable();
  $user_obj = user_load($user->uid);
  $email = $user_obj->field_miniorange_email[LANGUAGE_NONE][0]['value'];
  // Fetch the test QR code from miniorange auth api
  // against the email and set SESSION against the same.
  if (isset($form_state['triggering_element']) && $form_state['triggering_element']['#parents'][0] == 'test_phone') {
    $_SESSION['mo2f']['mo2f_show_qr_code'] = 'MO_2_FACTOR_SHOW_QR_CODE_TEST';
    get_qr_code_for_test_configuration($email);
    drupal_goto(
          'admin/config/mo2f/mo2f_tfa/setup-two-factor/user/' . $user_obj->uid . '/tfa/configure-mobile', array(
            'query' => array('qrcode' => 'test'),
          )
      );
  }
  // Fetch the Configure QR code from miniorange auth api
  // against the email and set SESSION against the same.
  if (isset($form_state['triggering_element']) && $form_state['triggering_element']['#parents'][0] == 'configure_phone') {
    $_SESSION['mo2f']['mo2f_show_qr_code'] = 'MO_2_FACTOR_SHOW_QR_CODE_CONFIGURE';
    mo2f_get_qr_code_for_mobile($email);
    drupal_goto(
          'admin/config/mo2f/mo2f_tfa/setup-two-factor/user/' . $user_obj->uid . '/tfa/configure-mobile', array(
            'query' => array('qrcode' => 'configure'),
            'fragment' => 'displayQrCode',
          )
      );
  }
  elseif (isset($form_state['triggering_element']) && $form_state['triggering_element']['#parents'][0] == 'qr_scan_submit') {
    // Validate if QR code is successfully scaned
    // using miniorange authenticater APP.
    if ($_SESSION['mo2f']['mo2f_show_qr_code'] == 'MO_2_FACTOR_SHOW_QR_CODE_TEST' && !empty($_SESSION['check_set'])) {
      unset($_SESSION['check_set']);
      $check_mobile_status = new two_factor_setup();

      $content = $check_mobile_status->check_mobile_status($_SESSION['mo2f']['mo2f_transactionId']);
      $response = json_decode($content, TRUE);
      if (json_last_error() == JSON_ERROR_NONE) {
        if ($response['status'] == 'SUCCESS') {
          unset($_SESSION['mo2f']);
          $user_obj->field_registration_status[LANGUAGE_NONE][0]['value'] = TWO_FACTOR_AUTHENTICATION_MO_2_FACTOR_PLUGIN_SETTINGS;
          user_save($user_obj);
          drupal_set_message(t('You have successfully completed the test.'));
          drupal_goto('admin/config/mo2f/mo2f_tfa/setup-two-factor');
          exit;
        }
        else {
          drupal_set_message(t('Invalid session submited'), 'error');
          drupal_goto('admin/config/mo2f/mo2f_tfa/setup-two-factor');
          exit;
        }
      }
      else {
        drupal_set_message(t('Invalid request.'), 'error');
        drupal_goto('admin/config/mo2f/mo2f_tfa/setup-two-factor');
        exit;
      }
    }
    else {
      if (!in_array(TWO_FACTOR_AUTHENTICATION_QR_CODE_AUTHENTICATION, $configured_methods) && !in_array(TWO_FACTOR_AUTHENTICATION_SOFT_TOKEN, $configured_methods) && !in_array(TWO_FACTOR_AUTHENTICATION_PUSH_NOTIFICATION, $configured_methods)) {
        array_push($user_obj->field_configured_methods[LANGUAGE_NONE], array('value' => TWO_FACTOR_AUTHENTICATION_QR_CODE_AUTHENTICATION));
        array_push($user_obj->field_configured_methods[LANGUAGE_NONE], array('value' => TWO_FACTOR_AUTHENTICATION_SOFT_TOKEN));
        array_push($user_obj->field_configured_methods[LANGUAGE_NONE], array('value' => TWO_FACTOR_AUTHENTICATION_PUSH_NOTIFICATION));
      }
      $user_obj->field_active_methods[LANGUAGE_NONE][0]['value'] = $_SESSION['mo2f']['active'];
      user_save($user_obj);
      if (in_array('authenticated user', $user_obj->roles)) {
        if ($_SESSION['mo2f']['active'] == TWO_FACTOR_AUTHENTICATION_EMAIL_VERIFICATION) {
          $users_active_method_name = t('Email Verification');
        }
        elseif ($_SESSION['mo2f']['active'] == TWO_FACTOR_AUTHENTICATION_OTP_OVER_SMS) {
          $users_active_method_name = t('OTP Over SMS');
        }
        elseif ($_SESSION['mo2f']['active'] == TWO_FACTOR_AUTHENTICATION_PHONE_VERIFICATION) {
          $users_active_method_name = t('Phone Call Verification');
        }
        elseif ($_SESSION['mo2f']['active'] == TWO_FACTOR_AUTHENTICATION_SOFT_TOKEN) {
          $users_active_method_name = t('Soft Token');
        }
        elseif ($_SESSION['mo2f']['active'] == TWO_FACTOR_AUTHENTICATION_QR_CODE_AUTHENTICATION) {
          $users_active_method_name = t('QR Code Authentication');
        }
        elseif ($_SESSION['mo2f']['active'] == TWO_FACTOR_AUTHENTICATION_PUSH_NOTIFICATION) {
          $users_active_method_name = t('Push Notification');
        }
        elseif ($_SESSION['mo2f']['active'] == TWO_FACTOR_AUTHENTICATION_GOOGLE_AUTHENTICATOR) {
          $users_active_method_name = t('Google Authenticator');
        }
        else {
          $users_active_method_name = 'NONE';
        }
        $meth_name = ucwords($users_active_method_name);
        drupal_set_message(t('<b>@methname</b> is set as your 2nd factor method. <a href="@clickhere">Click Here</a> to test @methname method', array(
            '@methname' => $meth_name,
            '@clickhere' => url('admin/config/mo2f/mo2f_tfa/qrtest', array('query' => array('qrcode' => 'test'))),
          )), 'status');
        drupal_goto('admin/config/mo2f/mo2f_tfa/setup-two-factor');
      }
      else {
        drupal_set_message(t('Qr Code configured'), 'status');
        $form_state['rebuild'] = TRUE;
      }
      unset($_SESSION['mo2f']);
    }
  }
}

/**
 * Helper function to register a mobile against a user.
 */
function mo2f_get_qr_code_for_mobile($email) {

  $register_mobile = new two_factor_setup();
  // Get QR Code form miniorange against email id.
  $content = $register_mobile->register_mobile($email);
  $response = json_decode($content, TRUE);
  if (json_last_error() == JSON_ERROR_NONE) {

    if (isset($response['statusCode']) && $response['statusCode'] == 'ERROR') {
      unset($_SESSION['mo2f']);
    }
    else {
      $_SESSION['mo2f']['mo2f_qrCode'] = $response['qrCode'];
      $_SESSION['mo2f']['mo2f_transactionId'] = $response['txId'];
      $_SESSION['mo2f']['mo2f_show_qr_code'] = 'MO_2_FACTOR_SHOW_QR_CODE_CONFIGURE';
    }
  }
}

/**
 * Helper function to create a customer in miniorange.
 */
function mo2f_create_customer(&$user) {

  $email = $user->field_miniorange_email[LANGUAGE_NONE][0]['value'];
  $phone = (!empty($user->field_phone‎[LANGUAGE_NONE][0]['value'])) ? $user->field_phone‎[LANGUAGE_NONE][0]['value'] : '';
  $password = variable_get('mo2f_password');
  // Create a new customer on miniorange through its API.
  $customer = new customer_setup();
  $customer_key = json_decode($customer->create_customer($email, $phone, $password), TRUE);

  if ((!empty($customer_key['statusCode'])) && $customer_key['statusCode'] == 'ERROR') {
    if(!empty($customer_key['statusMessage']))
      drupal_set_message($customer_key['statusMessage'], 'error');
  }
  else {
    if (strcasecmp($customer_key['status'], 'CUSTOMER_USERNAME_ALREADY_EXISTS') == 0) {
      // Admin already exists in miniOrange.
      mo2f_fetch_customer($user, $email, $password);
    }
    else {
      // Set the fetched values in Drupal database.
      mo2f_save_retrived_data($user, $customer_key);
    }
  }
  return $user;
}

/**
 * Function to fetch customer key from miniorange.
 */
function mo2f_fetch_customer(&$user, $email, $password) {

  $customer = new customer_setup();
  $content = $customer->get_customer_key($email, $password);
  $customer_key = json_decode($content, TRUE);

  if (json_last_error() == JSON_ERROR_NONE) {
    if (isset($customer_key['statusCode']) && $customer_key['statusCode'] == 'ERROR') {
      if(!empty($customer_key['statusMessage']))
        drupal_set_message($customer_key['statusMessage'], 'error');
    }
    else {
      // Set the fetched values in Drupal database.
      mo2f_save_retrived_data($user, $customer_key, 'exits');
    }
  }
  else {

    if(!empty($content) && $content == 'Invalid username or password. Please try again.') {
      drupal_set_message(t($content), 'error');
      drupal_goto('user/tfa/set-session');
      exit;
    }
    else {
      drupal_set_message(t('Invalid email or password. Please try again.'), 'error');
    }
    $user->field_miniorange_email[LANGUAGE_NONE][0]['value'] = $email;
    $user->field_registration_status[LANGUAGE_NONE][0]['value'] = TWO_FACTOR_AUTHENTICATION_MO_2_FACTOR_VERIFY_CUSTOMER;
  }
  return $user;
}

/**
 * Function to retrieve data based related to user saved methods.
 */
function mo2f_save_retrived_data(&$user, $customer_key, $exits = NULL) {
  variable_set('two_factor_authentication_mo2f_customerKey', $customer_key['id']);
  variable_set('two_factor_authentication_mo2f_api_key', $customer_key['apiKey']);
  variable_set('two_factor_authentication_mo2f_customer_token', $customer_key['token']);
  variable_set('two_factor_authentication_mo2f_customer_appSecret', $customer_key['appSecret']);
  $user->field_active_methods[LANGUAGE_NONE][0]['value'] = array(TWO_FACTOR_AUTHENTICATION_EMAIL_VERIFICATION);
  $user->field_configured_methods[LANGUAGE_NONE][0]['value'] = array(TWO_FACTOR_AUTHENTICATION_EMAIL_VERIFICATION);
  $user->field_registration_status[LANGUAGE_NONE][0]['value'] = TWO_FACTOR_AUTHENTICATION_MO_2_FACTOR_INITIALIZE_MOBILE_REGISTRATION;
  variable_del('mo2f_password');

  drupal_set_message(t('Your account has been @exits successfully. Email Verification has been set as your default 2nd factor method. <a href="@clickhere">Click Here</a> to configure another 2nd factor authentication method.', array(
      '@clickhere' => url('admin/config/mo2f/mo2f_tfa/setup-two-factor', array('absolute' => TRUE)),
      '@exits' => (empty($exits)) ? 'created' : 'retrieved',
    )
  ));
  return $user;
}

/**
 * Helper function to get QR Code form miniorange Auth.
 */
function get_qr_code_for_test_configuration($email) {

  $_SESSION['check_set'] = TRUE;
  $challenge_mobile = new customer_setup();
  $content = $challenge_mobile->send_otp_token($email, 'MOBILE AUTHENTICATION', variable_get('two_factor_authentication_mo2f_customerKey'), variable_get('two_factor_authentication_mo2f_api_key'));
  $response = json_decode($content, TRUE);

  if (json_last_error() == JSON_ERROR_NONE) {
    /* Generate Qr code */

    if ((isset($response['statusCode']) && ($response['statusCode'] == 'ERROR'))) {
      unset($_SESSION['mo2f']);
      if(!empty($response['statusMessage']))
        drupal_set_message($response['statusMessage'], 'error');
    }
    elseif (isset($response['status']) && $response['status'] == 'FAILED') {
      unset($_SESSION['mo2f']);
      if(!empty($response['message']))
        drupal_set_message($response['message'], 'error');
    }
    else {
      $_SESSION['mo2f']['mo2f_qrCode'] = $response['qrCode'];
      $_SESSION['mo2f']['mo2f_transactionId'] = $response['txId'];
      $_SESSION['mo2f']['mo2f_show_qr_code'] = 'MO_2_FACTOR_SHOW_QR_CODE_TEST';
      drupal_set_message(t('Please scan the QR Code now.'));
    }
  }
  else {
    drupal_set_message(t('Invalid request. Please try again'), 'error');
  }
}

/**
 * Helper function to send OTP on mail.
 */
function tfa_user_send_otp($user, $ajax = 'nojs') {

  $email = $user->field_miniorange_email[LANGUAGE_NONE][0]['value'];
  $default_customerkey = variable_get('two_factor_authentication_mo2f_customerKey', '16555');
  $default_api_key = variable_get('two_factor_authentication_mo2f_api_key', 'fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq');
  // Send OTP over mail using miniorange API.
  $customer = new customer_setup();
  $content = json_decode($customer->send_otp_token($email, 'EMAIL', $default_customerkey, $default_api_key), TRUE);

  if (strcasecmp($content['status'], 'SUCCESS') == 0) {
    drupal_set_message(
          t('An OTP has been sent to :email . Please enter the OTP below to verify your email.'), array(
            ':email' => '<b>' . $email . '</b>',
          )
      );
    $_SESSION['mo2f']['mo2f_transactionId'] = $content['txId'];
    $user->field_registration_status[LANGUAGE_NONE][0]['value'] = TWO_FACTOR_AUTHENTICATION_MO_2_FACTOR_OTP_DELIVERED_SUCCESS;
  }
  else {
    drupal_set_message(t('There was an error in sending OTP over email. Please click on Resend OTP to try again.'), 'error');
    $user->field_registration_status[LANGUAGE_NONE][0]['value'] = TWO_FACTOR_AUTHENTICATION_MO_2_FACTOR_OTP_DELIVERED_FAILURE;
  }
  user_save($user);

  $is_ajax = $ajax === 'ajax';
  if ($is_ajax) {
      $commands = array();
      $commands[] = ajax_command_remove('.otp-message');
      $commands[] = ajax_command_after('.resend-otp', '<div class = "otp-message">OTP Successfully sent.</div>');

      return array(
        '#type' => 'ajax',
        '#commands' => $commands,
      );
    }
}

/**
 * MiniOrange troubleshooting page.
 */
function tfa_user_help_and_troubleshooting() {

  // Call theme() function, so that Drupal includes
  // the tfa_troubleshooting.tpl.php template.
  return theme('tfa_troubleshooting');
}

/**
 * MiniOrange how it works page.
 */
function tfa_user_how_it_works() {

  // Call theme() function, so that Drupal includes the tpl.php template.
  return theme('tfa_howitworks');
}

/**
 * Contact us form miniorange.
 */
function tfa_user_contact_us($form, $form_state) {

  global $user;
  $current_user = user_load($user->uid);
  $country_codes = phone_country_codes();

  $form['support'] = array(
    '#type' => 'fieldset',
    '#title' => t('Support'),
    '#description' => t('Need any help? Just send us a query so we can help you.'),
    '#collapsed' => FALSE,
    '#collapsible' => FALSE,
  );

  $form['support']['email'] = array(
    '#type' => 'textfield',
    '#title' => t('Email'),
    '#default_value' => isset($current_user->field_miniorange_email[LANGUAGE_NONE][0]['value']) ? $current_user->field_miniorange_email[LANGUAGE_NONE][0]['value'] : '',
    '#required' => TRUE,
  );

  $form['support']['country_code'] = array(
    '#type' => 'select',
    '#options' => $country_codes,
    '#default_value' => '+1',
  );

  $form['support']['phone'] = array(
    '#type' => 'textfield',
    '#title' => t('Phone'),
    '#default_value' => variable_get('two_factor_authentication_mo2f_phone'),
    '#required' => TRUE,
  );

  $form['support']['clear'] = array(
    '#type' => 'item',
    '#prefix' => '<div class="clear">',
    '#suffix' => '</div>',
  );

  $form['support']['query'] = array(
    '#type' => 'textarea',
    '#title' => t('Query'),
    '#attributes' => array('placeholder' => t('Write your query here')),
    '#required' => TRUE,
  );

  $form['support']['submit'] = array('#type' => 'submit', '#value' => t('Submit Query'));

  return $form;
}

/**
 * Contact us submit handler.
 */
function tfa_user_contact_us_submit($form, $form_state) {

  $email = $form_state['values']['email'];
  $phone = $form_state['values']['phone'];
  $query = $form_state['values']['query'];
  // Post Query to miniorange through its api.
  $contact_us = new customer_setup();
  $submited = json_decode($contact_us->submit_contact_us($email, $phone, $query), TRUE);
  if (json_last_error() == JSON_ERROR_NONE) {
    if ($submited['statusCode'] == 'ERROR') {
      if(!empty($submited['statusMessage']))
        drupal_set_message($submited['statusMessage']);
    }
    else {
      if ($submited == FALSE) {
        drupal_set_message(t('Your query could not be submitted. Please try again.'), 'error');
      }
      else {
        drupal_set_message(t('Thanks for getting in touch! We shall get back to you shortly.'));
      }
    }
  }
}

/**
 * Helper function to test the QR code functionality for user.
 */
function tfa_user_qrtest() {

  global $user, $base_url;
  // Load user to get email id.
  $user_obj = user_load($user->uid);
  $email = $user_obj->field_miniorange_email[LANGUAGE_NONE][0]['value'];

  if(empty($_SESSION['check_set'])) {
    $_SESSION['mo2f']['mo2f_show_qr_code'] = 'MO_2_FACTOR_SHOW_QR_CODE_TEST';
    get_qr_code_for_test_configuration($email);
  }

  // Get the required form.
  $form = drupal_get_form('tfa_user_configure_mobile');
  // Hide all the elements that we don't need for this form.
  hide($form['mobile_conf']);
  hide($form['configure_phone']);
  hide($form['back']);

  // Set weight for qr image.
  $form['mobile_conf_qrcode']['#weight'] = 5;

  // Configure user message if unable to scan it.
  $form['mobile_user_msg']['#markup'] = '<div style="color:red;"><b>If your are not able to scan the QR code,</b></div>
  		<div>
				<br>Follow these instructions below and try again.
				<ol>
					<li>Make sure your desktop screen has enough brightness.</li>
					<li>Open your app and click on Green button (your registered email is displayed on the button) to scan QR Code.</li>
					<li>If you get cross mark on QR Code then click on \'Back\' button and again click on \'Test\' link.</li>
				</ol>
			</div>';

  // Configure back button for this page.
  $form['back_test']['#type'] = 'button';
  $form['back_test']['#weight'] = 6;
  $form['back_test']['#value'] = t('Back');
  $form['back_test']['#id'] = 'edit-back';

  // Tell form to redirect to 2 step authetication.
  $form_state['redirect'] = $base_url . '/admin/config/mo2f/mo2f_tfa/setup-two-factor';

  // Print the required form.
  return drupal_render($form);
}

/**
 * Helper function to test the Google Authenticator functionality for user.
 */
function tfa_user_gatest($form, &$form_state) {

  $_SESSION['mo2f']['mo2f_show_qr_code'] = 'TWO_FACTOR_AUTHENTICATION_GOOGLE_AUTHENTICATOR';

  // Get the required form.
  $form['ga_otp'] = array(
    '#type' => 'textfield',
    '#title' => 'Enter verification code',
    '#description' => t('Get a verification code from "Google Authenticator" app'),
    '#placeholder' => t('Enter OTP'),
    '#element_validate' => array('element_validate_integer_positive'),
    '#weight' => 2,
    '#required' => TRUE,
  );

  $form['validate_ga'] = array(
    '#type' => 'submit',
    '#value' => 'Validate OTP',
    '#weight' => 3,
  );

  // Configure back button for this page.
  $form['back_test']['#type'] = 'button';
  $form['back_test']['#weight'] = 4;
  $form['back_test']['#value'] = t('Back');
  $form['back_test']['#id'] = 'edit-back';

  // Print the required form.
  return $form;
}

/**
 * Validate function for Google Authentication Test.
 */
function tfa_user_gatest_validate($form, &$form_state) {
  // This is checked here because OTP field gets
  // validate and form is not redirected.
  if (isset($form_state['triggering_element']) && $form_state['triggering_element']['#parents'][0] == 'back_test') {
    unset($_SESSION['check_set']);
    drupal_get_messages();
    drupal_goto('admin/config/mo2f/mo2f_tfa/setup-two-factor');
    exit;
  }
}

/**
 * Submit handler for Google Authenticator test form.
 */
function tfa_user_gatest_submit($form, &$form_state) {
  global $user;
  // Load user to get email id.
  $user_obj = user_load($user->uid);
  $email = $user_obj->field_miniorange_email[LANGUAGE_NONE][0]['value'];
  $softtoken = $form_state['values']['ga_otp'];

  $customer = new Customer_Setup();
  $content = json_decode($customer->validate_otp_token('GOOGLE AUTHENTICATOR', $email, NULL, $softtoken), TRUE);
  if (strcasecmp($content['status'], 'SUCCESS') == 0) {
    drupal_set_message(t('You have successfully completed the test. Now <a href="@clickhere">Click Here</a> to go to Login Settings.', array('@clickhere' => url('admin/config/mo2f/mo2f_tfa/settings', array('absolute' => TRUE)))), 'status');
    $form_state['redirect'] = 'admin/config/mo2f/mo2f_tfa/setup-two-factor';
  }
  else {
    $message = $_SESSION['mo2f']['mo_2factor_login_status'] == 'MO_2_FACTOR_CHALLENGE_SOFT_TOKEN' ? 'Invalid OTP. <b>Please try again after clicking on the Settings icon in the app and press Sync button.</b>' : 'Invalid OTP. Please try again';
    drupal_set_message(t(':message', array(':message' => $message)), 'error');
  }
}
